// Compiled by ClojureScript 1.10.773 {:target :nodejs}
goog.provide('ctmx.form');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('clojure.walk');
ctmx.form.nest_params = (function ctmx$form$nest_params(params){
return cljs.core.reduce.call(null,(function (m,p__2221){
var vec__2222 = p__2221;
var k = cljs.core.nth.call(null,vec__2222,(0),null);
var v = cljs.core.nth.call(null,vec__2222,(1),null);
return cljs.core.assoc_in.call(null,m,cljs.core.name.call(null,k).split("_"),v);
}),cljs.core.PersistentArrayMap.EMPTY,params);
});
ctmx.form.prune_params = (function ctmx$form$prune_params(m){
while(true){
if(cljs.core._EQ_.call(null,(1),cljs.core.count.call(null,m))){
if(((cljs.core.vector_QMARK_.call(null,m)) && (cljs.core.coll_QMARK_.call(null,cljs.core.peek.call(null,m))))){
var G__2225 = cljs.core.peek.call(null,m);
m = G__2225;
continue;
} else {
if(((cljs.core.map_QMARK_.call(null,m)) && (cljs.core.coll_QMARK_.call(null,cljs.core.second.call(null,cljs.core.first.call(null,m)))))){
var G__2226 = cljs.core.second.call(null,cljs.core.first.call(null,m));
m = G__2226;
continue;
} else {
return m;

}
}
} else {
return m;
}
break;
}
});
ctmx.form.first_val = (function ctmx$form$first_val(p__2227){
var vec__2228 = p__2227;
var s = cljs.core.nth.call(null,vec__2228,(0),null);
return Number(s);
});
ctmx.form.vectorize_map = (function ctmx$form$vectorize_map(m){
if(cljs.core.truth_(((cljs.core.map_QMARK_.call(null,m))?(function (){var and__4115__auto__ = cljs.core.not_empty.call(null,m);
if(cljs.core.truth_(and__4115__auto__)){
return cljs.core.every_QMARK_.call(null,(function (p1__2231_SHARP_){
return cljs.core.re_find.call(null,/^\d+$/,p1__2231_SHARP_);
}),cljs.core.keys.call(null,m));
} else {
return and__4115__auto__;
}
})():false))){
return cljs.core.mapv.call(null,cljs.core.second,cljs.core.sort_by.call(null,ctmx.form.first_val,m));
} else {
return m;
}
});
ctmx.form.json_params = (function ctmx$form$json_params(params){
return clojure.walk.keywordize_keys.call(null,clojure.walk.postwalk.call(null,ctmx.form.vectorize_map,ctmx.form.nest_params.call(null,params)));
});
ctmx.form.json_params_pruned = (function ctmx$form$json_params_pruned(params){
return ctmx.form.prune_params.call(null,ctmx.form.json_params.call(null,params));
});
ctmx.form.flatten_json = (function ctmx$form$flatten_json(var_args){
var G__2235 = arguments.length;
switch (G__2235) {
case 1:
return ctmx.form.flatten_json.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 3:
return ctmx.form.flatten_json.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(ctmx.form.flatten_json.cljs$core$IFn$_invoke$arity$1 = (function (m){
return ctmx.form.flatten_json.call(null,cljs.core.PersistentVector.EMPTY,cljs.core.PersistentArrayMap.EMPTY,m);
}));

(ctmx.form.flatten_json.cljs$core$IFn$_invoke$arity$3 = (function (stack,done,m){
return cljs.core.reduce.call(null,(function (done__$1,p__2236){
var vec__2237 = p__2236;
var k = cljs.core.nth.call(null,vec__2237,(0),null);
var v = cljs.core.nth.call(null,vec__2237,(1),null);
var stack__$1 = cljs.core.conj.call(null,stack,cljs.core.name.call(null,k));
if(((cljs.core.map_QMARK_.call(null,v)) || (cljs.core.vector_QMARK_.call(null,v)))){
return ctmx.form.flatten_json.call(null,stack__$1,done__$1,v);
} else {
return cljs.core.assoc.call(null,done__$1,cljs.core.keyword.call(null,clojure.string.join.call(null,"_",stack__$1)),v);
}
}),done,((cljs.core.map_QMARK_.call(null,m))?m:cljs.core.map_indexed.call(null,(function (p1__2232_SHARP_,p2__2233_SHARP_){
return (new cljs.core.List(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__2232_SHARP_),(new cljs.core.List(null,p2__2233_SHARP_,null,(1),null)),(2),null));
}),m)));
}));

(ctmx.form.flatten_json.cljs$lang$maxFixedArity = 3);

ctmx.form.apply_params = (function ctmx$form$apply_params(var_args){
var args__4742__auto__ = [];
var len__4736__auto___2244 = arguments.length;
var i__4737__auto___2245 = (0);
while(true){
if((i__4737__auto___2245 < len__4736__auto___2244)){
args__4742__auto__.push((arguments[i__4737__auto___2245]));

var G__2246 = (i__4737__auto___2245 + (1));
i__4737__auto___2245 = G__2246;
continue;
} else {
}
break;
}

var argseq__4743__auto__ = ((((2) < args__4742__auto__.length))?(new cljs.core.IndexedSeq(args__4742__auto__.slice((2)),(0),null)):null);
return ctmx.form.apply_params.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4743__auto__);
});

(ctmx.form.apply_params.cljs$core$IFn$_invoke$arity$variadic = (function (params,f,args){
var $ = params;
var $__$1 = ctmx.form.json_params.call(null,$);
var $__$2 = cljs.core.apply.call(null,f,$__$1,args);
return ctmx.form.flatten_json.call(null,$__$2);
}));

(ctmx.form.apply_params.cljs$lang$maxFixedArity = (2));

/** @this {Function} */
(ctmx.form.apply_params.cljs$lang$applyTo = (function (seq2241){
var G__2242 = cljs.core.first.call(null,seq2241);
var seq2241__$1 = cljs.core.next.call(null,seq2241);
var G__2243 = cljs.core.first.call(null,seq2241__$1);
var seq2241__$2 = cljs.core.next.call(null,seq2241__$1);
var self__4723__auto__ = this;
return self__4723__auto__.cljs$core$IFn$_invoke$arity$variadic(G__2242,G__2243,seq2241__$2);
}));

ctmx.form.apply_params_stack = (function ctmx$form$apply_params_stack(var_args){
var args__4742__auto__ = [];
var len__4736__auto___2251 = arguments.length;
var i__4737__auto___2252 = (0);
while(true){
if((i__4737__auto___2252 < len__4736__auto___2251)){
args__4742__auto__.push((arguments[i__4737__auto___2252]));

var G__2253 = (i__4737__auto___2252 + (1));
i__4737__auto___2252 = G__2253;
continue;
} else {
}
break;
}

var argseq__4743__auto__ = ((((3) < args__4742__auto__.length))?(new cljs.core.IndexedSeq(args__4742__auto__.slice((3)),(0),null)):null);
return ctmx.form.apply_params_stack.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4743__auto__);
});

(ctmx.form.apply_params_stack.cljs$core$IFn$_invoke$arity$variadic = (function (params,stack,f,args){
var $ = params;
var $__$1 = ctmx.form.json_params.call(null,$);
var $__$2 = cljs.core.apply.call(null,cljs.core.update_in,$__$1,cljs.core.mapv.call(null,cljs.core.keyword,stack),f,args);
return ctmx.form.flatten_json.call(null,$__$2);
}));

(ctmx.form.apply_params_stack.cljs$lang$maxFixedArity = (3));

/** @this {Function} */
(ctmx.form.apply_params_stack.cljs$lang$applyTo = (function (seq2247){
var G__2248 = cljs.core.first.call(null,seq2247);
var seq2247__$1 = cljs.core.next.call(null,seq2247);
var G__2249 = cljs.core.first.call(null,seq2247__$1);
var seq2247__$2 = cljs.core.next.call(null,seq2247__$1);
var G__2250 = cljs.core.first.call(null,seq2247__$2);
var seq2247__$3 = cljs.core.next.call(null,seq2247__$2);
var self__4723__auto__ = this;
return self__4723__auto__.cljs$core$IFn$_invoke$arity$variadic(G__2248,G__2249,G__2250,seq2247__$3);
}));

ctmx.form.apply_middleware = (function ctmx$form$apply_middleware(req,p__2254,stack){
var vec__2255 = p__2254;
var k = cljs.core.nth.call(null,vec__2255,(0),null);
var f = cljs.core.nth.call(null,vec__2255,(1),null);
var G__2258 = k;
var G__2258__$1 = (((G__2258 instanceof cljs.core.Keyword))?G__2258.fqn:null);
switch (G__2258__$1) {
case "req":
return f.call(null,req);

break;
case "params":
return cljs.core.update.call(null,req,new cljs.core.Keyword(null,"params","params",710516235),ctmx.form.apply_params,f,req);

break;
case "params-stack":
return cljs.core.update.call(null,req,new cljs.core.Keyword(null,"params","params",710516235),ctmx.form.apply_params_stack,stack,f,req);

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__2258__$1)].join('')));

}
});

//# sourceMappingURL=form.js.map
