// Compiled by ClojureScript 1.10.773 {:target :nodejs}
goog.provide('ctmx.rt');
goog.require('cljs.core');
goog.require('ctmx.config');
goog.require('ctmx.form');
goog.require('cljs.reader');
goog.require('ctmx.render');
goog.require('clojure.string');
goog.require('ctmx.response');
ctmx.rt.parse_int = (function ctmx$rt$parse_int(p1__2262_SHARP_){
if(typeof p1__2262_SHARP_ === 'string'){
return Number(p1__2262_SHARP_);
} else {
return p1__2262_SHARP_;
}
});
ctmx.rt.parse_float = (function ctmx$rt$parse_float(p1__2263_SHARP_){
if(typeof p1__2263_SHARP_ === 'string'){
return Number(p1__2263_SHARP_);
} else {
return p1__2263_SHARP_;
}
});
ctmx.rt.parse_ints = (function ctmx$rt$parse_ints(p1__2264_SHARP_){
if(typeof p1__2264_SHARP_ === 'string'){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [ctmx.rt.parse_int.call(null,p1__2264_SHARP_)], null);
} else {
return cljs.core.map.call(null,ctmx.rt.parse_int,p1__2264_SHARP_);
}
});
ctmx.rt.parse_floats = (function ctmx$rt$parse_floats(p1__2265_SHARP_){
if(typeof p1__2265_SHARP_ === 'string'){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [ctmx.rt.parse_float.call(null,p1__2265_SHARP_)], null);
} else {
return cljs.core.map.call(null,ctmx.rt.parse_float,p1__2265_SHARP_);
}
});
ctmx.rt.parse_array = (function ctmx$rt$parse_array(p1__2266_SHARP_){
if(typeof p1__2266_SHARP_ === 'string'){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__2266_SHARP_], null);
} else {
return p1__2266_SHARP_;
}
});
ctmx.rt.parse_boolean = (function ctmx$rt$parse_boolean(p1__2267_SHARP_){
var G__2268 = p1__2267_SHARP_;
if(cljs.core._EQ_.call(null,true,G__2268)){
return true;
} else {
if(cljs.core._EQ_.call(null,false,G__2268)){
return false;
} else {
return cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, ["true",null,"on",null], null), null),p1__2267_SHARP_);

}
}
});
ctmx.rt.parse_boolean_true = (function ctmx$rt$parse_boolean_true(p1__2269_SHARP_){
var G__2270 = p1__2269_SHARP_;
if(cljs.core._EQ_.call(null,true,G__2270)){
return true;
} else {
if(cljs.core._EQ_.call(null,false,G__2270)){
return false;
} else {
return cljs.core.not_EQ_.call(null,"false",p1__2269_SHARP_);

}
}
});
ctmx.rt.parse_edn = (function ctmx$rt$parse_edn(p1__2271_SHARP_){
if(typeof p1__2271_SHARP_ === 'string'){
return cljs.reader.read_string.call(null,p1__2271_SHARP_);
} else {
return p1__2271_SHARP_;
}
});
ctmx.rt.conj_stack = (function ctmx$rt$conj_stack(n,p__2272){
var map__2273 = p__2272;
var map__2273__$1 = (((((!((map__2273 == null))))?(((((map__2273.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__2273.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__2273):map__2273);
var req = map__2273__$1;
var headers = cljs.core.get.call(null,map__2273__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var stack = cljs.core.get.call(null,map__2273__$1,new cljs.core.Keyword(null,"stack","stack",-793405930));
var stack__$1 = ((cljs.core.empty_QMARK_.call(null,stack))?(function (){var temp__5752__auto__ = cljs.core.get.call(null,headers,"hx-target");
if(cljs.core.truth_(temp__5752__auto__)){
var target = temp__5752__auto__;
return cljs.core.pop.call(null,cljs.core.vec.call(null,target.split("_")));
} else {
return cljs.core.PersistentVector.EMPTY;
}
})():stack);
return cljs.core.assoc.call(null,req,new cljs.core.Keyword(null,"stack","stack",-793405930),((typeof cljs.core.peek.call(null,stack__$1) === 'number')?cljs.core.conj.call(null,cljs.core.pop.call(null,stack__$1),n,cljs.core.peek.call(null,stack__$1)):cljs.core.conj.call(null,stack__$1,n)));
});
ctmx.rt.get_value = (function ctmx$rt$get_value(params,json,stack,value,method){
var G__2275 = (function (){var or__4126__auto__ = method;
if(cljs.core.truth_(or__4126__auto__)){
return or__4126__auto__;
} else {
return ctmx.config.default_param_method;
}
})();
var G__2275__$1 = (((G__2275 instanceof cljs.core.Keyword))?G__2275.fqn:null);
switch (G__2275__$1) {
case "simple":
return params.call(null,cljs.core.keyword.call(null,value));

break;
case "path":
return params.call(null,cljs.core.keyword.call(null,clojure.string.join.call(null,"_",cljs.core.conj.call(null,stack,value))));

break;
case "json":
return json.call(null,cljs.core.keyword.call(null,value));

break;
case "json-stack":
return cljs.core.get_in.call(null,json,cljs.core.mapv.call(null,cljs.core.keyword,cljs.core.conj.call(null,stack,value)));

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__2275__$1)].join('')));

}
});
ctmx.rt.concat_stack = (function ctmx$rt$concat_stack(concat,stack){
return cljs.core.reduce.call(null,(function (stack__$1,x){
var G__2277 = x;
switch (G__2277) {
case "..":
return cljs.core.pop.call(null,stack__$1);

break;
case ".":
return stack__$1;

break;
default:
return cljs.core.conj.call(null,stack__$1,x);

}
}),stack,concat);
});
ctmx.rt.path = (function ctmx$rt$path(prefix,stack,p){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(prefix),clojure.string.join.call(null,"_",(cljs.core.truth_(p.startsWith("/"))?cljs.core.rest.call(null,p.split("/")):ctmx.rt.concat_stack.call(null,p.split("/"),stack)))].join('');
});
ctmx.rt.path_find = (function ctmx$rt$path_find(var_args){
var G__2281 = arguments.length;
switch (G__2281) {
case 3:
return ctmx.rt.path_find.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return ctmx.rt.path_find.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(ctmx.rt.path_find.cljs$core$IFn$_invoke$arity$3 = (function (prefix,stack,find){
return ctmx.rt.path_find.call(null,prefix,stack,find,".");
}));

(ctmx.rt.path_find.cljs$core$IFn$_invoke$arity$4 = (function (prefix,stack,find,p){
var $ = stack;
var $__$1 = cljs.core.reverse.call(null,$);
var $__$2 = cljs.core.drop_while.call(null,(function (p1__2279_SHARP_){
return cljs.core.not_EQ_.call(null,find,p1__2279_SHARP_);
}),$__$1);
var $__$3 = cljs.core.reverse.call(null,$__$2);
var $__$4 = cljs.core.vec.call(null,$__$3);
return ctmx.rt.path.call(null,prefix,$__$4,p);
}));

(ctmx.rt.path_find.cljs$lang$maxFixedArity = 4);

ctmx.rt.map_indexed = (function ctmx$rt$map_indexed(f,req,s){
return cljs.core.map_indexed.call(null,(function (i,x){
return f.call(null,ctmx.rt.conj_stack.call(null,i,req),i,x);
}),s);
});
ctmx.rt.map_range = (function ctmx$rt$map_range(var_args){
var G__2285 = arguments.length;
switch (G__2285) {
case 3:
return ctmx.rt.map_range.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return ctmx.rt.map_range.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(ctmx.rt.map_range.cljs$core$IFn$_invoke$arity$3 = (function (f,req,i){
return ctmx.rt.map_range.call(null,f,req,(0),i);
}));

(ctmx.rt.map_range.cljs$core$IFn$_invoke$arity$4 = (function (f,req,i,j){
return cljs.core.map.call(null,(function (p1__2283_SHARP_){
return f.call(null,ctmx.rt.conj_stack.call(null,p1__2283_SHARP_,req));
}),cljs.core.range.call(null,ctmx.rt.parse_int.call(null,i),ctmx.rt.parse_int.call(null,j)));
}));

(ctmx.rt.map_range.cljs$lang$maxFixedArity = 4);

ctmx.rt.redirect = (function ctmx$rt$redirect(path){
return (function (req){
return ctmx.response.redirect.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(path),"?",cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"query-string","query-string",-1018845061).cljs$core$IFn$_invoke$arity$1(req))].join(''));
});
});

//# sourceMappingURL=rt.js.map
