// Compiled by ClojureScript 1.10.773 {:target :nodejs}
goog.provide('ctmx.form');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('clojure.walk');
ctmx.form.nest_params = (function ctmx$form$nest_params(params){
return cljs.core.reduce.call(null,(function (m,p__5620){
var vec__5621 = p__5620;
var k = cljs.core.nth.call(null,vec__5621,(0),null);
var v = cljs.core.nth.call(null,vec__5621,(1),null);
return cljs.core.assoc_in.call(null,m,cljs.core.name.call(null,k).split("_"),v);
}),cljs.core.PersistentArrayMap.EMPTY,params);
});
ctmx.form.prune_params = (function ctmx$form$prune_params(m){
while(true){
if(cljs.core._EQ_.call(null,(1),cljs.core.count.call(null,m))){
if(((cljs.core.vector_QMARK_.call(null,m)) && (cljs.core.coll_QMARK_.call(null,cljs.core.peek.call(null,m))))){
var G__5624 = cljs.core.peek.call(null,m);
m = G__5624;
continue;
} else {
if(((cljs.core.map_QMARK_.call(null,m)) && (cljs.core.coll_QMARK_.call(null,cljs.core.second.call(null,cljs.core.first.call(null,m)))))){
var G__5625 = cljs.core.second.call(null,cljs.core.first.call(null,m));
m = G__5625;
continue;
} else {
return m;

}
}
} else {
return m;
}
break;
}
});
ctmx.form.first_val = (function ctmx$form$first_val(p__5626){
var vec__5627 = p__5626;
var s = cljs.core.nth.call(null,vec__5627,(0),null);
return Number(s);
});
ctmx.form.vectorize_map = (function ctmx$form$vectorize_map(m){
if(cljs.core.truth_(((cljs.core.map_QMARK_.call(null,m))?(function (){var and__4115__auto__ = cljs.core.not_empty.call(null,m);
if(cljs.core.truth_(and__4115__auto__)){
return cljs.core.every_QMARK_.call(null,(function (p1__5630_SHARP_){
return cljs.core.re_find.call(null,/^\d+$/,p1__5630_SHARP_);
}),cljs.core.keys.call(null,m));
} else {
return and__4115__auto__;
}
})():false))){
return cljs.core.mapv.call(null,cljs.core.second,cljs.core.sort_by.call(null,ctmx.form.first_val,m));
} else {
return m;
}
});
ctmx.form.json_params = (function ctmx$form$json_params(params){
return clojure.walk.keywordize_keys.call(null,clojure.walk.postwalk.call(null,ctmx.form.vectorize_map,ctmx.form.nest_params.call(null,params)));
});
ctmx.form.json_params_pruned = (function ctmx$form$json_params_pruned(params){
return ctmx.form.prune_params.call(null,ctmx.form.json_params.call(null,params));
});
ctmx.form.flatten_json = (function ctmx$form$flatten_json(var_args){
var G__5634 = arguments.length;
switch (G__5634) {
case 1:
return ctmx.form.flatten_json.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 3:
return ctmx.form.flatten_json.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(ctmx.form.flatten_json.cljs$core$IFn$_invoke$arity$1 = (function (m){
return ctmx.form.flatten_json.call(null,cljs.core.PersistentVector.EMPTY,cljs.core.PersistentArrayMap.EMPTY,m);
}));

(ctmx.form.flatten_json.cljs$core$IFn$_invoke$arity$3 = (function (stack,done,m){
return cljs.core.reduce.call(null,(function (done__$1,p__5635){
var vec__5636 = p__5635;
var k = cljs.core.nth.call(null,vec__5636,(0),null);
var v = cljs.core.nth.call(null,vec__5636,(1),null);
var stack__$1 = cljs.core.conj.call(null,stack,cljs.core.name.call(null,k));
if(((cljs.core.map_QMARK_.call(null,v)) || (cljs.core.vector_QMARK_.call(null,v)))){
return ctmx.form.flatten_json.call(null,stack__$1,done__$1,v);
} else {
return cljs.core.assoc.call(null,done__$1,cljs.core.keyword.call(null,clojure.string.join.call(null,"_",stack__$1)),v);
}
}),done,((cljs.core.map_QMARK_.call(null,m))?m:cljs.core.map_indexed.call(null,(function (p1__5631_SHARP_,p2__5632_SHARP_){
return (new cljs.core.List(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__5631_SHARP_),(new cljs.core.List(null,p2__5632_SHARP_,null,(1),null)),(2),null));
}),m)));
}));

(ctmx.form.flatten_json.cljs$lang$maxFixedArity = 3);

ctmx.form.apply_params = (function ctmx$form$apply_params(var_args){
var args__4742__auto__ = [];
var len__4736__auto___5643 = arguments.length;
var i__4737__auto___5644 = (0);
while(true){
if((i__4737__auto___5644 < len__4736__auto___5643)){
args__4742__auto__.push((arguments[i__4737__auto___5644]));

var G__5645 = (i__4737__auto___5644 + (1));
i__4737__auto___5644 = G__5645;
continue;
} else {
}
break;
}

var argseq__4743__auto__ = ((((2) < args__4742__auto__.length))?(new cljs.core.IndexedSeq(args__4742__auto__.slice((2)),(0),null)):null);
return ctmx.form.apply_params.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4743__auto__);
});

(ctmx.form.apply_params.cljs$core$IFn$_invoke$arity$variadic = (function (params,f,args){
var $ = params;
var $__$1 = ctmx.form.json_params.call(null,$);
var $__$2 = cljs.core.apply.call(null,f,$__$1,args);
return ctmx.form.flatten_json.call(null,$__$2);
}));

(ctmx.form.apply_params.cljs$lang$maxFixedArity = (2));

/** @this {Function} */
(ctmx.form.apply_params.cljs$lang$applyTo = (function (seq5640){
var G__5641 = cljs.core.first.call(null,seq5640);
var seq5640__$1 = cljs.core.next.call(null,seq5640);
var G__5642 = cljs.core.first.call(null,seq5640__$1);
var seq5640__$2 = cljs.core.next.call(null,seq5640__$1);
var self__4723__auto__ = this;
return self__4723__auto__.cljs$core$IFn$_invoke$arity$variadic(G__5641,G__5642,seq5640__$2);
}));

ctmx.form.apply_params_stack = (function ctmx$form$apply_params_stack(var_args){
var args__4742__auto__ = [];
var len__4736__auto___5650 = arguments.length;
var i__4737__auto___5651 = (0);
while(true){
if((i__4737__auto___5651 < len__4736__auto___5650)){
args__4742__auto__.push((arguments[i__4737__auto___5651]));

var G__5652 = (i__4737__auto___5651 + (1));
i__4737__auto___5651 = G__5652;
continue;
} else {
}
break;
}

var argseq__4743__auto__ = ((((3) < args__4742__auto__.length))?(new cljs.core.IndexedSeq(args__4742__auto__.slice((3)),(0),null)):null);
return ctmx.form.apply_params_stack.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4743__auto__);
});

(ctmx.form.apply_params_stack.cljs$core$IFn$_invoke$arity$variadic = (function (params,stack,f,args){
var $ = params;
var $__$1 = ctmx.form.json_params.call(null,$);
var $__$2 = cljs.core.apply.call(null,cljs.core.update_in,$__$1,cljs.core.mapv.call(null,cljs.core.keyword,stack),f,args);
return ctmx.form.flatten_json.call(null,$__$2);
}));

(ctmx.form.apply_params_stack.cljs$lang$maxFixedArity = (3));

/** @this {Function} */
(ctmx.form.apply_params_stack.cljs$lang$applyTo = (function (seq5646){
var G__5647 = cljs.core.first.call(null,seq5646);
var seq5646__$1 = cljs.core.next.call(null,seq5646);
var G__5648 = cljs.core.first.call(null,seq5646__$1);
var seq5646__$2 = cljs.core.next.call(null,seq5646__$1);
var G__5649 = cljs.core.first.call(null,seq5646__$2);
var seq5646__$3 = cljs.core.next.call(null,seq5646__$2);
var self__4723__auto__ = this;
return self__4723__auto__.cljs$core$IFn$_invoke$arity$variadic(G__5647,G__5648,G__5649,seq5646__$3);
}));

ctmx.form.apply_middleware = (function ctmx$form$apply_middleware(req,p__5653,stack){
var vec__5654 = p__5653;
var k = cljs.core.nth.call(null,vec__5654,(0),null);
var f = cljs.core.nth.call(null,vec__5654,(1),null);
var G__5657 = k;
var G__5657__$1 = (((G__5657 instanceof cljs.core.Keyword))?G__5657.fqn:null);
switch (G__5657__$1) {
case "req":
return f.call(null,req);

break;
case "params":
return cljs.core.update.call(null,req,new cljs.core.Keyword(null,"params","params",710516235),ctmx.form.apply_params,f,req);

break;
case "params-stack":
return cljs.core.update.call(null,req,new cljs.core.Keyword(null,"params","params",710516235),ctmx.form.apply_params_stack,stack,f,req);

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__5657__$1)].join('')));

}
});
