// Compiled by ClojureScript 1.10.773 {:target :nodejs}
goog.provide('ctmx.intercept');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('clojure.walk');
goog.require('ctmx.render');
ctmx.intercept.query_string = (function ctmx$intercept$query_string(args){
if((cljs.core.count.call(null,args) > (0))){
return ["?",clojure.string.join.call(null,"&",cljs.core.map.call(null,(function (p__4428){
var vec__4429 = p__4428;
var k = cljs.core.nth.call(null,vec__4429,(0),null);
var v = cljs.core.nth.call(null,vec__4429,(1),null);
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(k),"=",cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join('');
}),args))].join('');
} else {
return "";
}
});
ctmx.intercept.mock_xhr = ({"status": (200), "getAllResponseHeaders": (function (){
return "";
})});
ctmx.intercept.log_request = (function ctmx$intercept$log_request(request_config){
return console.log(request_config.verb.toUpperCase(),["/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(request_config.path),ctmx.intercept.query_string.call(null,cljs.core.js__GT_clj.call(null,request_config.parameters))].join(''));
});
ctmx.intercept.lowercaseize = (function ctmx$intercept$lowercaseize(headers){
return cljs.core.zipmap.call(null,cljs.core.map.call(null,(function (p1__4432_SHARP_){
return cljs.core.name.call(null,p1__4432_SHARP_).toLowerCase();
}),cljs.core.keys.call(null,headers)),cljs.core.vals.call(null,headers));
});
ctmx.intercept.get_in_js = (function ctmx$intercept$get_in_js(s){
return cljs.core.reduce.call(null,(function (o,s__$1){
return (o[s__$1]);
}),window,s.split("."));
});
ctmx.intercept.eval_map = (function ctmx$intercept$eval_map(m){
return cljs.core.zipmap.call(null,cljs.core.keys.call(null,m),cljs.core.map.call(null,ctmx.intercept.get_in_js,cljs.core.vals.call(null,m)));
});
ctmx.intercept.coerce_static = (function ctmx$intercept$coerce_static(m){
return cljs.core.assoc.call(null,cljs.core.update.call(null,m,new cljs.core.Keyword(null,"headers","headers",-835030129),ctmx.intercept.lowercaseize),new cljs.core.Keyword(null,"params","params",710516235),new cljs.core.Keyword(null,"parameters","parameters",-1229919748).cljs$core$IFn$_invoke$arity$1(m),new cljs.core.Keyword(null,"request-method","request-method",1764796830),cljs.core.keyword.call(null,new cljs.core.Keyword(null,"verb","verb",-1492655803).cljs$core$IFn$_invoke$arity$1(m)));
});
ctmx.intercept.wrap_response = (function ctmx$intercept$wrap_response(req,f){
var f_result = f.call(null,ctmx.intercept.coerce_static.call(null,clojure.walk.keywordize_keys.call(null,cljs.core.js__GT_clj.call(null,req))));
if((f_result == null)){
return null;
} else {
if(cljs.core.truth_(f_result.then)){
return f_result.then((function (p1__4433_SHARP_){
return ctmx.render.html.call(null,p1__4433_SHARP_);
}));
} else {
return ctmx.render.html.call(null,f_result);

}
}
});
ctmx.intercept.log_QMARK_ = false;
ctmx.intercept.set_responses_BANG_ = (function ctmx$intercept$set_responses_BANG_(metas){
(ctmx.intercept.responses = ctmx.intercept.eval_map.call(null,cljs.core.apply.call(null,cljs.core.merge,cljs.core.map.call(null,new cljs.core.Keyword(null,"deps","deps",1883360319),metas))));

return htmx.defineExtension("intercept",({"onEvent": (function (name,evt){
if(ctmx.intercept.log_QMARK_){
console.log(name,evt);
} else {
}

var G__4434 = name;
switch (G__4434) {
case "htmx:beforeRequest":
var xhr = evt.detail.xhr;
var request_config = evt.detail.requestConfig;
var swap = (function (swap){
(ctmx.intercept.to_swap = swap);

return xhr.onload();
});
(evt.detail.xhr = ctmx.intercept.mock_xhr);

return (xhr.send = (function (){
var temp__5752__auto__ = ctmx.intercept.responses.call(null,request_config.path);
if(cljs.core.truth_(temp__5752__auto__)){
var f = temp__5752__auto__;
var r = ctmx.intercept.wrap_response.call(null,request_config,f);
if(cljs.core.truth_((function (){var G__4435 = r;
if((G__4435 == null)){
return null;
} else {
return G__4435.then;
}
})())){
return r.then(swap);
} else {
return swap.call(null,r);
}
} else {
return swap.call(null,null);
}
}));

break;
case "htmx:beforeSwap":
return cljs.core.boolean$.call(null,ctmx.intercept.to_swap);

break;
default:
return null;

}
}), "transformResponse": (function (_,___$1,___$2){
return ctmx.intercept.to_swap;
})}));
});
