// Compiled by ClojureScript 1.10.773 {:target :nodejs}
goog.provide('ctmx_electron.service.minecraft_dir');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('ctmx_electron.service.storage');
goog.require('ctmx_electron.util');
ctmx_electron.service.minecraft_dir.fs = require("fs");

ctmx_electron.service.minecraft_dir.os = require("os");
ctmx_electron.service.minecraft_dir.home_dir = ctmx_electron.service.minecraft_dir.os.homedir();
ctmx_electron.service.minecraft_dir.default_dir = ((ctmx_electron.util.osx_QMARK_)?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(ctmx_electron.service.minecraft_dir.home_dir),"/Library/Application Support/minecraft"].join(''):((ctmx_electron.util.windows_QMARK_)?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(process.env.APPDATA),"\\.minecraft"].join(''):((ctmx_electron.util.linux_QMARK_)?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(ctmx_electron.service.minecraft_dir.home_dir),"/.minecraft"].join(''):null)));
ctmx_electron.service.minecraft_dir.dir = (function ctmx_electron$service$minecraft_dir$dir(){
if(cljs.core.truth_(ctmx_electron.service.minecraft_dir.fs.existsSync(ctmx_electron.service.minecraft_dir.default_dir))){
return ctmx_electron.service.minecraft_dir.default_dir;
} else {
return ctmx_electron.service.storage.get_minecraft_dir.call(null);
}
});
ctmx_electron.service.minecraft_dir.exists_QMARK_ = (function ctmx_electron$service$minecraft_dir$exists_QMARK_(){
var or__4126__auto__ = ctmx_electron.service.minecraft_dir.fs.existsSync(ctmx_electron.service.minecraft_dir.default_dir);
if(cljs.core.truth_(or__4126__auto__)){
return or__4126__auto__;
} else {
var temp__5752__auto__ = ctmx_electron.service.storage.get_minecraft_dir.call(null);
if(cljs.core.truth_(temp__5752__auto__)){
var dir = temp__5752__auto__;
return ctmx_electron.service.minecraft_dir.fs.existsSync(dir);
} else {
return false;
}
}
});
ctmx_electron.service.minecraft_dir.update_dir_BANG_ = (function ctmx_electron$service$minecraft_dir$update_dir_BANG_(elt){
var $ = elt;
var $__$1 = $.files;
var $__$2 = ($__$1[(0)]);
var $__$3 = $__$2.path;
var $__$4 = $__$3.split(ctmx_electron.util.file_separator);
var $__$5 = cljs.core.butlast.call(null,$__$4);
var $__$6 = clojure.string.join.call(null,ctmx_electron.util.file_separator,$__$5);
return ctmx_electron.service.storage.set_minecraft_dir.call(null,$__$6);
});
ctmx_electron.service.minecraft_dir.game_dir = (function ctmx_electron$service$minecraft_dir$game_dir(f){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(ctmx_electron.service.minecraft_dir.dir.call(null)),ctmx_electron.util.file_separator,"saves",ctmx_electron.util.file_separator,cljs.core.str.cljs$core$IFn$_invoke$arity$1(f)].join('');
});
ctmx_electron.service.minecraft_dir.chunkmapper_QMARK_ = (function ctmx_electron$service$minecraft_dir$chunkmapper_QMARK_(f){
return ctmx_electron.service.minecraft_dir.fs.existsSync([ctmx_electron.service.minecraft_dir.game_dir.call(null,f),ctmx_electron.util.file_separator,"chunkmapper"].join(''));
});
ctmx_electron.service.minecraft_dir.saves = (function ctmx_electron$service$minecraft_dir$saves(){
var $ = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(ctmx_electron.service.minecraft_dir.dir.call(null)),ctmx_electron.util.file_separator,"saves"].join('');
var $__$1 = (cljs.core.truth_(ctmx_electron.service.minecraft_dir.fs.existsSync($))?ctmx_electron.service.minecraft_dir.fs.readdirSync($,({"withFileTypes": true})):cljs.core.List.EMPTY);
var $__$2 = cljs.core.filter.call(null,(function (p1__6508_SHARP_){
return p1__6508_SHARP_.isDirectory();
}),$__$1);
var $__$3 = cljs.core.map.call(null,(function (p1__6509_SHARP_){
return p1__6509_SHARP_.name;
}),$__$2);
return cljs.core.filter.call(null,ctmx_electron.service.minecraft_dir.chunkmapper_QMARK_,$__$3);
});
ctmx_electron.service.minecraft_dir.delete_BANG_ = (function ctmx_electron$service$minecraft_dir$delete_BANG_(name){
return ctmx_electron.service.minecraft_dir.fs.rmdirSync(ctmx_electron.service.minecraft_dir.game_dir.call(null,name),({"recursive": true}));
});
